;================================
;          ZX-Assembler-2 
;      by Artic Computing LTD
;================================
; Save Sprite background
;
;  PRINT AT Y,X;USR SBKG;C$
;================================
@Print=0ACF			;ROM PRINT routine
@LookVars=111C			;ROM find var routine
@DFxCC=400E			;Print address in DFile
@CHAdd=4016			;Character address
@XDim=4036			;X Dim store, CoordX=16438
;================================
@BKGSave			;Save background
	RST 20			;Get Next chr
	CALL LookVars
	JR NC +2		;Jump if var found
@ErrorZ
	RST 08
	01			;Error Code 2
	INC HL			;Skip header
	INC HL 
	INC HL
	LD A,(HL)		;Get Y dim
	SUB 1C
	LD B,A			;B=Y dim
	INC HL
	LD A,(HL) 		;Get X dim
	SUB 1C
	LD (XDim),A		;Store X dim
	INC HL			;Start of data
	EX DE,HL		;DE=Data pointer
	LD HL,(DFxCC)		;HL=DFile addr
@SaveRow
	PUSH HL			;PUSH DFile pointer
	LD A,(XDim)		;Get X dim
	LD C,A			;C=X dim
@SaveCol			;Skip over N/L's
	LD A,(HL)		;Get DFile chr
	BIT 6,A			;N/L?
	JR Z NotNL		;Jump if not N/L
	PUSH BC			;PUSH counters
	LD BC,0021		;Row offset
	AND A			;Clear CY
	SBC HL,BC		;Wrap right
	POP BC			;POP counters
	INC HL
@NotNL
	PUSH BC			;PUSH counters
	LD A,(HL)		;Get DFile chr
	LD (DE),A		;Save to Array
	POP BC			;POP counters
	INC HL			;Increase DFile pointer
	INC DE			;Increase data pointer
	DEC C			;Decrease counter
	JR NZ SaveCol		;Loop until C=0
@NextRow
	POP HL			;POP DFile pointer
	LD A,B			;Save counter
	LD BC,0021		;Row offset
	ADD HL,BC		;Next row
	LD B,A			;Restore counter
	DJNZ SaveRow		;Start next row
	LD HL,(CHAdd)
	LD A,(HL)
	CP 19			;Test for ";"
	JR Z +2			;Jump if ";", more print statements
	RST 08			;Return via Error Restart, skipping the PRINT routine
	FF
	INC HL			;(HL)=AT token
	LD (CHAdd),HL
	JP Print		;Jump to PRINT AT
