;================================
;          ZX-Assembler-2 
;      by Artic Computing LTD
;================================
; Sprite Print
;
;  PRINT AT Y,X;USR SPRT;C$
;
;================================

@Print=0ACF			;ROM PRINT routine
@LookVars=111C			;ROM find var routine
@DFxCC=400E			;Print address in DFile
@CHAdd=4016			;Character address
@XDim=4036			;X Dim store, (IY+54)
@Speed=4037			;Speed POKE, (IY+55)
;================================
@SpritePrint			;Print Sprite
	RES 7,(IY+55)		;Reset bit 7 of speed to 0, max=127
	RST 20			;Get Next chr
@FindVar
	CALL LookVars
	JR NC +2		;Jump if var found
@Error2
	RST 08
	01			;Error Code 2
	LD A,(HL)		;Check for Z$
	CP 5F			;Z$?
	JR NZ 04		;Jump if not Z$
	SET 7,(IY+55)		;Set bit 7 of speed to 1
	INC HL			;Skip header
	INC HL 
	INC HL			
	LD A,(HL)		;Get Y dim 
	SUB 1C
	LD B,A			;B=Y dim
	INC HL
	LD A,(HL) 		;Get X dim
	SUB 1C
	LD (XDim),A		;Store X dim
	INC HL			;Start of data
	EX DE,HL		;DE=Data pointer
	LD HL,(DFxCC)		;HL=DFile addr
@PrintRow
	PUSH HL			;PUSH DFile pointer
	LD A,(XDim)		;Get X dim
	LD C,A			;C=X dim
@PrintCol			;Skip over N/L's
	LD A,(HL)		;Get DFile chr
	BIT 6,A			;N/L?
	JR Z NotNL		;Jump if not N/L
	PUSH BC			;PUSH counters
	LD BC,0021		;Row offset
	AND A			;Clear CY
	SBC HL,BC		;Wrap right
	POP BC			;POP counter
	INC HL
@NotNL
	LD A,(DE)		;Get chr to print
	LD (HL),A		;Print the chr.
	INC HL			;Increase DFile pointer
	INC DE			;Increase data pointer
	DEC C			;Decrease counter
	JR NZ PrintCol		;Loop until C=0
@NextRow
	POP HL			;POP DFile pointer
	LD A,B			;Save counter
	LD BC,0021		;Row offset
	ADD HL,BC		;Next row
	LD B,A			;Restore counter
	DJNZ PrintRow		;Start next row
@End
	LD A,(Speed)		;Get speed
	BIT 7,A			;Test bit 7 of speed
	JR Z +1			;Jump if 0
	XOR A			;Set speed to 0
	LD H,A
	LD L,01
	DEC HL			;Decrease counter
	LD A,H 
	OR L
	JR NZ -5		;Loop until HL=0
	LD HL,(CHAdd)
	LD A,(HL)
	CP 19			;Test for ";"
	JR Z +2			;Jump if ";", more print statements
@Done
	RST 08			;Return via Error Restart, skipping the PRINT routine
	FF
	INC HL			;Next chr addr.
	LD (CHAdd),HL
	LD A,(HL)		;Get next chr
	CP C1			;AT Token?
	JP Z Print		;Print sprite
	BIT 6,A
	JR Z FindVar
	JR Done
	